#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(2222248-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 130, 70, 35);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(45);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{

		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2+GetStgFrameWidth/3*GetBossSide, GetStgFrameHeight/3, 9, 6);
		Hold(90);
		while(ObjMove_GetSpeed(Enemy) > 0.5){yield;}
		let dir = 0;
		let way = 0.5;
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			ascent(h in 0..60){
				ascent(i in 0..8){
					let id = 132;
					if(i%2 == 0){
						id = 121;
					}
					let shot = CreateObjShotA1(EnemyX,EnemyY,4,dir+(i*360/8),id,10);
					ObjRender_SetBlendType(shot, BLEND_ADD_ARGB);
					if(i%2 == 0){
						Obj_SetValue(shot, "Breakable", false);
					}
					// ObjShot_SetSpellResist(shot,true);
					//if (h%2 == 0) {ObjShot_SetSpellResist(shot,false);}
				}
				dir+=1*way;
				PlaySoundO2(e_shot_00,65);
				if(!Hold(1)){break;}
			}
			ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2+rand(-120,120),rand(60,100), 13, 8);
			loop(40){
				dir+=1*way;
				if(!Hold(1)){break;}
			}
			way*=-1;
			dir = 0;
			if(!Hold(1)){break;}
		}
	}	
}