#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(55-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 180, 42/5, 12/5);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(75);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		let face = GetCurrentScriptDirectory~"face/Aoji_";
		ObjCutin_SetSpellcardM4("Torrential Oddity \"Streamlined Whirlpool\"", 3500000, "ALLSTAR_LN", face~"02.png", 128, 164, 255);
		// ObjCutin_SetSpellcardLayersM4([face~"04.png"]);
		PlaySoundO1(spell_0);
		yield;
		ObjEnemyBossScene_StartSpell(objScene);
	
		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/3, 9, 6);
		Hold(90);
		Hold(90);
		row(1);
		row(-1);
		while(ObjEnemy_GetInfo(GetRealBoss, INFO_LIFE) > 300 && !EnemyDead){
			if(!Hold(150)){break;}
			ObjMove_SetDestAtWeightLimitedA1(Enemy, GetStgFrameWidth/2+rand(-120,120),GetStgFrameHeight/3+rand(-90,50), 72+argument/3, 8, 8, 13, 4);
			crisscross;
		}
		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/3, 6, 2.25);
		if(!Hold(40)){break;}
		while(ObjEnemy_GetInfo(GetRealBoss, INFO_LIFE) > 0 && !EnemyDead){
			if(!Hold(120)){break;}
			ObjMove_SetDestAtWeightLimitedA1(Enemy, GetStgFrameWidth/2+rand(-120,120),GetStgFrameHeight/3+rand(-90,50), 42, 3, 3, 10, 0.25+argument/85);
		
			if(!Hold(120)){break;}
		}
	}
	
	task row(way){
		let dis = 110;
		while(ObjEnemy_GetInfo(GetRealBoss, INFO_LIFE) > 0 && !EnemyDead){
			if (ObjEnemy_GetInfo(GetRealBoss, INFO_LIFE) < 300 && dis > 66-argument/3) {dis-=2;}
			let x = ObjMove_GetX(Enemy)+(dis)*way;
			ascent(i in 0..8){
				let shot = CreateObjShotA1(x+rand(0, 20)*way,-50,6+rand(0,3),90,238,10);
				x += 28*way;
			}
			PlaySoundO2(e_shot_00,40);
			if(!Hold(4)){break;}
		}
	}
	task crisscross{
		if (ObjEnemy_GetInfo(GetRealBoss, INFO_LIFE) > 300){
		let dir = rand(0,360);
		let way = 1;
		ascent(i in 0..2){
		loop(10){
			let shot = CreateObjShotA1(EnemyX,EnemyY,3,dir,259+(i*2),20);
			ObjMove_SetAngularVelocity(shot,0.7*way);
			dir+=360/10;
		}
		way*=-1;
		}
		PlaySoundO1(e_shot_01);
		}
	}
}