#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(44-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 160, 92/4, 95/4);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		let face = GetCurrentScriptDirectory~"face/Aoji_";
		ObjCutin_SetSpellcardM4("Water Rush \"Blue Vortex\"", 3500000, "ALLSTAR_LN", face~"02.png", 128, 164, 255);
		// ObjCutin_SetSpellcardLayersM4([face~"04.png"]);
		yield;
		
		Hold(90);
		let way = 1;
		Hold(120);
		let pspd = 0.75;
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			let dir = rand(0,360);
			let pang = GetAngleToPlayer(Enemy)-90;
			let st = rand(0,360);
			ascent(i in 0..70){
				if(i%1==0){
					ascent(j in 0..5){
						// let shot = CreateObjShotA1(EnemyX,EnemyY,5*pspd,pang+dir,8,10);
						let shot = CreateObjShotA1(EnemyX,EnemyY,5,dir,55,10);
						swerve(shot,dir,8,5,0,70-i);
						// swerveshou(shot,dir,9*pspd,6,dir,10); //shou attack
						dir+=360/5;
					}
				}
				PlaySoundO2(e_shot_00,65);
				if(!Hold(1)){break;}
			}
			if(!Hold(220)){break;}
			ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/2+(140*way),80,13,5);
			if(!Hold(30)){break;}
			side(way);
			if(!Hold(190)){break;}
			ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/4, 13, 5);
			if(!Hold(90)){break;}
			way*=-1;
		}
	}
	
	task swerve(obj,ang,amt,speed,startpoint,time){
		let flux = startpoint;
		
		let spd = 1;
		ang+=90;
		let xm = spd*cos(ang);
		let ym = spd*sin(ang);
		
		while(!Obj_IsDeleted(obj)) {
			flux+=speed;
			time--;
			ObjMove_SetAngularVelocity(obj,0+amt*sin(flux));
			if(time <= 0){
				ObjMove_SetPosition(obj, ObjMove_GetX(obj)-xm, ObjMove_GetY(obj)-ym);
			}
			yield;
		}
	}
	
	task swerveshou(obj,ang,amt,speed,startpoint,time){
		wait(time);
		let flux = startpoint;
		
		let spd = 0.3;
		let xm = spd*cos(ang+180);
		let ym = spd*sin(ang+180);
		
		while(!Obj_IsDeleted(obj)) {
			flux+=speed;
			ObjMove_SetAngularVelocity(obj,0+amt*sin(flux));
			ObjMove_SetPosition(obj, ObjMove_GetX(obj)+xm, ObjMove_GetY(obj)+ym);
			yield;
		}
	}
	
	task swervewithneateffect(obj,ang,amt,speed,startpoint,time){
		wait(time);
		let flux = startpoint;
		
		let spd = 5;
		let xm = 5;//cool effect stuff
		let ym = 0; 
		
		while(!Obj_IsDeleted(obj)) {
			flux+=speed;
			ObjMove_SetAngularVelocity(obj,0+amt*sin(flux));
			ObjMove_SetPosition(obj, ObjMove_GetX(obj)+xm, ObjMove_GetY(obj)+ym);
			yield;
		}
	}
}

task side(way) {
	let dir = rand(0,360);
	loop(20){
	loop(10){
		ascent (i in 0..2){
			let shot = CreateObjShotA1(EnemyX,EnemyY,5,dir+i*6,19,10);
			ObjMove_SetAngularVelocity(shot,0.7*way);
		}
		dir+=360/10;
	}
	PlaySoundO2(e_shot_01,65);
	wait(8);
	}
} 