#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(4228-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 60, 100, 80);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(40);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/3, 9, 6);
		Hold(90);
		let dir = rand(0,360);
		let way = 1;
		Alternatingbeams(12);
		Hold(90);
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			ascent(i in 0..12){
				CreateObjShotA1(EnemyX,EnemyY,0.8,dir,89,10);
				CreateObjShotA1(EnemyX,EnemyY,1.1,dir+(360/12/3*2*way),1,10);
				CreateObjShotA1(EnemyX,EnemyY,1.4,dir+(360/12/3*way),137,10);
				dir+=360/12;
			}
			
			PlaySoundO2(e_shot_01,75);
			dir = rand(0,360);
			way*=-1;
			if(!Hold(110)){break;}
			ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2+rand(-100,100),rand(80,120), 13, 5);
			if(!Hold(70)){break;}
		}
	}
	
	task Alternatingbeams(sp){
		let spacing = GetStgFrameWidth/sp;
		let max = GetStgFrameWidth;
		let X1 = spacing;
		let X2 = max;
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			
			let L1 = CreateExplodeLaserA1(X1-spacing/2-5, rand(150,240), 90, 14, 113, 30);
			
			X1+=spacing;
			if(!Hold(20)){break;}
			if (X1 > GetStgFrameWidth) {X1 = spacing;}
			
			let L2 = CreateExplodeLaserA1(X2-5, rand(150,240), 90, 14, 113, 30);
			
			X2-=spacing;
			if(!Hold(20)){break;}
			if (X2 < -spacing) {X2 = max;}
		}
	}
	
}

function LaserExpand(x, y, ang, wid, col){
	let a = CreateStraightLaserA1(x, y, ang, 0, wid, 2048, col, 0);
	// ObjRender_SetBlendType(a, BLEND_SUBTRACT);
	DoStuff;
	return a;
	
	task DoStuff{
		let minlen = 16+argument*0.4;
		let intlen = minlen*3;
		let endlend = 550+argument*3-(minlen+intlen);
		ObjLaser_SetLength(a, 0);
		let col = 108;
		
		ascent(i in 0..10){
			let mod = i/9;
			ObjLaser_SetLength(a, minlen*mod);
			yield;
		}
		
		let ytime = round(45-argument/3.4);
		let gtime = round(50-argument*0.16);
		let wtime = round(24+argument*0.14);
		
		// let lasercycle = round(45-argument/3.4)+round(50-argument*0.16)+round(24+argument*0.14)+40;
		// change this if you change above values
		
		while(!Obj_IsDeleted(a)){
			
			loop(ytime){yield;}
			
			ascent(i in 0..gtime){
				let nlen = minlen+intlen*i/(gtime-1);
				ObjLaser_SetLength(a, nlen);
				yield;
			}
			
			ascent(i in 0..20){
				let nlen = minlen+intlen+endlend*i/19;
				ObjLaser_SetLength(a, nlen);
				yield;
			}
			loop(wtime){yield;}
			descent(i in 0..20){
				let nlen = minlen+(intlen+endlend)*i/19;
				ObjLaser_SetLength(a, nlen);
				yield;
			}
			ObjLaser_SetLength(a, minlen);
		}
	}
}