#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(2222248-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 135, 80, 40);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(45);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/4-GetStgFrameHeight/5.5*GetBossSide, 5, 6);
	
		Hold(110);
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			let dir = rand(25,65);
			ascent(i in 0..2){
				let shot = CreateObjShotA1(EnemyX,EnemyY,2,dir+(i*90),1,10);
				ObjMove_SetAngularVelocity(shot,-0.7+(i*1.4));
				ExLaserGuide(shot,20);
				Obj_SetVisible(shot, false);
				ObjShot_SetIntersectionEnable(shot, false);
				if(!Hold(200)){break;}
			}
			//if(!Hold(100)){break;}
		}
	}
	
	task ExLaserGuide(obj,t){
		if(!Hold(t)){break;}
		while(!Obj_IsDeleted(obj)){
			let x = ObjMove_GetX(obj);
			let y = ObjMove_GetY(obj);
			let a = ObjMove_GetAngle(obj);
			if(CheckOutsideScreenA1(obj, 0)){break;}
			Exlasergroup(x,y,a+90,11,-1,2,111,30);
			if(!Hold(t)){break;}
		}
		
	}
	
	task Exlasergroup(x,y,ang,dist,mn,mx,graph,delmod){
		ascent(i in mn..mx){
		let a = CreateExplodeLaserA1(x+(i*dist)*cos(ang+90), y+(i*dist)*sin(ang+90), ang, 10, graph, delmod);
		}
	}
}

