#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(4228-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 180, 85/5, 40/5);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(65);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		
		let face = GetCurrentScriptDirectory~"face/Kunimitsu_";
		ObjCutin_SetSpellcardM4("Percise Cut \"Stitching Remover\"", 3500000, "ALLSTAR_LN", face~"07.png", 255, 192, 144);
		// ObjCutin_SetSpellcardLayersM4([face~"04.png"]);
		
		yield;
		PlaySoundO1(spell_0);
		ObjEnemyBossScene_StartSpell(objScene);

	
		Hold(90);
		Hold(90);
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			slash(0);
			if(!Hold(150)){break;}
			ObjMove_SetDestAtWeight(Enemy,120,120,7,20);
			if(!Hold(30)){break;}
			slash(1);
			ObjMove_SetDestAtSpeed(Enemy,292,120,7);
			if(!Hold(30)){break;}
			ObjMove_SetDestAtSpeed(Enemy,102,120,7);
			if(!Hold(40)){break;}
			ObjMove_SetDestAtWeight(Enemy,192,120,7,20);
			if(!Hold(10)){break;}
			ConcentrationA1(Enemy,"CHERRY",60,4,150,[255,192,56]);
			if(!Hold(110)){break;}
			vertslash;
			if(!Hold(180)){break;}
		}
	}
}

task slash(extra) {
	let r = rand(0,360);
	let count = r;
	ascent (i in 0..25) {
		count+=360/8;
		ascent(j in 0..3){
			CreateObjShotA2(EnemyX-90+i*8,EnemyY-90+i*8,0.7+(j*0.3),count,0.01,2.3,124,20);
		}
		PlaySoundO2(e_shot_00, 80);
		if(!Hold(1)){break;}
	}
	count = rand(0,360);
	if (extra == 1) {loop (3) {
		count+=360/3;
		//CreateObjShotA2(EnemyX+100,EnemyY+100,6,count,-0.2,1.4,227,10);
		CreateExplodeLaserA1(EnemyX+100, EnemyY+100, count, 14, 113, 10);
	}}
	if(!Hold(5)){break;}
	count = r;
	ascent (i in 0..25) {
		count+=360/8;
		ascent(j in 0..3){
			CreateObjShotA2(EnemyX+90-i*8,EnemyY-90+i*8,0.7+(j*0.3),count,0.01,2.3,124,20);
			
		}
		PlaySoundO2(e_shot_00, 80);
		if(!Hold(1)){break;}
	}
	count = rand(0,360);
	if (extra == 1) {loop (3) {
		count+=360/3;
		//CreateObjShotA2(EnemyX-100,EnemyY+100,6,count,-0.2,1.4,227,10);
		CreateExplodeLaserA1(EnemyX-100, EnemyY+100, count, 14, 113, 10);
	}}
}

task vertslash{
	
	Exlasergroup(EnemyX,EnemyY+50,90,12,-1,2,118,10);
	if(!Hold(70)){break;}
	let Y = 0;
	let dir = rand(0,360);
	PlaySoundO2(e_shot_01, 88);
	loop(10){
		ascent(i in 0..6){
			ascent(j in 0..4){
				CreateObjShotA2(EnemyX,Y,0.5+(j*0.4),dir+i*360/6,0.01,2.3,129,20);
			}
			Y+=GetStgFrameHeight/40;
		}
		dir+=360/6/2;
	}
	
	task Exlasergroup(x,y,ang,dist,mn,mx,graph,delmod){
		ascent(i in mn..mx){
		let a = CreateExplodeLaserA1(x+(i*dist)*cos(ang+90), y+(i*dist)*sin(ang+90), ang, 10, graph, delmod);
		}
	}
}