#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(2222248-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 180, 92/4, 95/4);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
	
		let argi = 180-round((argument^0.5)*10);
		let argm = 21-round((argument^0.58));
		let argw = 14+argument/15;
		
		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2-GetStgFrameWidth/3, GetStgFrameHeight/4, 9, 6);
		
		let face = GetCurrentScriptDirectory~"face/Kunimitsu_";
		ObjCutin_SetSpellcardM4("Quick Strike \"Air Slash\"", 3500000, "YABUSAME", face~"08.png", 164, 164, 128);
		yield;
		
		Hold(180);
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			// ObjMove_SetDestAtWeight(Enemy, GetMouseX-GetStgFrameLeft, GetMouseY-GetStgFrameTop, 13, 8);
			loop(2){
				ascent(i in 0..2){
					let mod = 1-2*i;
					ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2+(GetStgFrameWidth/3+rand(-24, 4))*mod, 
						GetStgFrameHeight/6+rand(-6, 6), 13, 8);
					FireLaserWall(Enemy);
					if(!Hold(argi+15)){break;}
					
					ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2+(GetStgFrameWidth/3+24+rand(-12, 12))*mod, 
						GetStgFrameHeight/2+rand(-6, 6), 13, 8);
					FireLaserWall(Enemy);
					if(!Hold(argi+15)){break;}
				}
			}
			if(argument >= 24){
				ascent(i in 0..2){
					let mod = 1-2*i;
					ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2-(GetStgFrameWidth/3)*mod,GetStgFrameHeight/6, 13, 8);
					if(!Hold(60)){break;}
					ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2+(GetStgFrameWidth/3)*mod,GetStgFrameHeight/6, 13, 8);
					while(ObjMove_GetSpeed(Enemy) >= 3){
						let a = CreateExplodeLaserA1(EnemyX, EnemyY, GetAngleToPlayer(Enemy)+180, argw, 94, 0);
						ObjRender_SetBlendType(a, BLEND_ALPHA);
						Obj_SetValue(a, "Damage", 42+argument/2);
						if(!Hold(ceil(argm*0.5))){break;}
					}
				}
			}
			if(!Hold(argi)){break;}
		}
		
		task FireLaserWall(obj){
			let a = ObjMove_GetAngle(obj);
			let x = ObjMove_GetX(obj);
			let y = ObjMove_GetY(obj);
			let cyc = 0;
			while(ObjMove_GetSpeed(Enemy) > 0.5){
				y = ObjMove_GetY(obj);
				x = ObjMove_GetX(obj);
				a = ObjMove_GetAngle(obj);
				let a = CreateExplodeLaserA1(x, y, a-90, argw, 89+(cyc%2), 0);
						ObjRender_SetBlendType(a, BLEND_ALPHA);
				Obj_SetValue(a, "Damage", 30+argument/3);
				cyc++;
				if(!Hold(argm)){break;}
			}
		}
	}
}