#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(2222248-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 160, 83, 40);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(70);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{

		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2+GetStgFrameWidth/5*GetBossSide, GetStgFrameHeight/3, 9, 6);
	
		Hold(60);
		Hold(90);
		let argm = round(1.2+argument/18);
		let argi = round(17+argument/2.2/(1+argm*0.14));
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			let dir = rand(0,360);
			let z = 0;
			
			PlaySoundO2(e_shot_01, 75);
			ascent(i in 0..30){
				CheckBullet(EnemyX+10*cos(dir),EnemyY+10*sin(dir),2+(sin(z)*0.4),dir,0,4,10);
				dir+=360/30;
				z+=360/10;
			}
			if(!Hold(50)){break;}
			ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2+rand(-100,100),rand(80,120), 13, 5);
			if(!Hold(100)){break;}
		}
	}
}








task CheckBullet(x, y, spd, ang, curve, graph, del){
	let shot = CreateObjShotA1(x, y, spd, ang, graph, del);
	let bounceCount = 0;
	
	ObjMove_SetAngularVelocity(shot,curve);
	
	let brect = GetShotDataInfoA1(graph, TARGET_ENEMY, INFO_RECT);
	let scale = max(max(absolute(brect[0] - brect[2]), absolute(brect[1] - brect[3])), 4)^0.1;
	scale *= 0.4;
	let rad = 64*scale/2;
	
	Obj_SetValue(shot, "DidBounce", false);
	Obj_SetValue(shot, "IsFalling", false);

	while(bounceCount == 0){
		CheckForBounce;
		yield;
	}
	Obj_SetValue(shot, "DidBounce", true);
	
	ObjShot_SetGraphic(shot, graph+1); //change to appropriate graphic
	
	
	let locBul = [];
	
	
	while(!Obj_GetValue(shot, "IsFalling") && !Obj_IsDeleted(shot)){
		CheckForBounce;
		let barr = GetShotIdInCircleA2(x, y, rad, TARGET_ENEMY);
		
		
		if(length(barr)>1){
			let IsReady = false;
			ascent(i in 1..length(barr)){
				let hitShot = barr[i];
				if(Obj_GetValue(hitShot, "DidBounce")){
					IsReady = true;
					ObjMove_SetSpeed(hitShot, 0);
					Obj_SetValue(hitShot, "IsFalling", true);
				}
			}
			if(IsReady){
				Obj_SetValue(shot, "IsFalling", true);
				locBul = barr;
			}
		}
		yield;
	}
	if(Obj_IsDeleted(shot)){return;}
	PlaySoundO2(warning, 60);
	ObjMove_SetSpeed(shot, 1);
	ObjMove_SetAngularVelocity(shot,0);
	ObjMove_SetAngle(shot, 90);
	ObjMove_SetMaxSpeed(shot, 1);
	ObjMove_SetAcceleration(shot, 1);
	
	
	sub CheckForBounce{
		x = ObjMove_GetX(shot);
		y = ObjMove_GetY(shot);
		ang = ObjMove_GetAngle(shot);
		if(x < 0 || x > GetStgFrameWidth){
			bounceCount++;
			ObjMove_SetAngle(shot, -ang-180);
		}
		// if(y < 0 || y > GetStgFrameHeight){
		if(y < 0){
			bounceCount++;
			ObjMove_SetAngle(shot, 360-ang);
		}
	}
}