#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(2222248-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 180, 70/5, 28/5);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(90);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{

		let face = GetCurrentScriptDirectory~"face/Shou_";
		ObjCutin_SetSpellcardM4("Rain Dance \"Slug Conga Line\"", 3500000, "ALLSTAR_LN", face~"02.png", 212, 212, 144);
		// ObjCutin_SetSpellcardLayersM4([face~"04.png"]);

		PlaySoundO1(spell_0);
		yield;
		ObjEnemyBossScene_StartSpell(objScene);
	
		Hold(90);
		Hold(90);
		let dir = rand(0,360);
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			PlaySoundO2(e_shot_01, 80);
			wave(0,GetStgFrameHeight,315,1);
			if(!Hold(150)){break;}
			PlaySoundO2(e_shot_01, 80);
			wave(GetStgFrameWidth,GetStgFrameHeight,225,-1);
			if(!Hold(150)){break;}
		}
	}
}

task wave(x,y,dir,way){
	ascent(i in -11..11){
		let shot = CreateObjShotA1(x+(i*40*way)*cos(dir+90),y+(i*40*way)*sin(dir+90),0,dir,132,10);
		ObjShot_SetAutoDelete(shot,false);
		weave(shot);
		if(!Hold(6)){break;}
	}
}

task weave(obj){
	loop(7){
		ObjMove_SetAcceleration(obj,0.05);
		ObjMove_SetMaxSpeed(obj,2);
		if(!Hold(140)){break;}
		ObjMove_SetAcceleration(obj,-0.05);
		ObjMove_SetMaxSpeed(obj,-2);
		if(!Hold(90)){break;}
	}
	Obj_Delete(obj);
}