#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(48-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 180, 85/5, 45/5);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(40);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{

		let face = GetCurrentScriptDirectory~"face/Shou_";
		ObjCutin_SetSpellcardM4("Slithering Card \"Backup Slugs\"", 3500000, "YABUSAME", face~"02.png", 164, 164, 128);
		// ObjCutin_SetSpellcardLayersM4([face~"04.png"]);
		
		yield;
		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2+GetStgFrameWidth/5*GetBossSide, GetStgFrameHeight/3, 9, 6);
	
		Hold(90);
		Hold(90);
		let dir = rand(0,360);
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			PlaySoundO2(e_shot_01, 80);
			wave(0,0-rand(0,60),45,1);
			ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/2+rand(-100,100),GetStgFrameHeight/3+rand(-20,20),13,5);
			if(!Hold(50)){break;}
			Fire;
			if(!Hold(100)){break;}
			PlaySoundO2(e_shot_01, 80);
			wave(GetStgFrameWidth,0-rand(0,60),135,-1);
			ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/2+rand(-100,100),GetStgFrameHeight/3+rand(-20,20),13,5);
			if(!Hold(50)){break;}
			Fire;
			if(!Hold(100)){break;}
		}
	}
}

task wave(x,y,dir,way){
	
	ascent(i in -8..8){
		let shot = CreateObjShotA1(x+(i*73*way)*cos(dir+90),y+(i*73*way)*sin(dir+90),3,dir,121,10);
		ObjShot_SetAutoDelete(shot,false);
		swerve(shot,2,3,90,0);
		if(!Hold(6)){break;}
	}
}

task wave2(x,y,dir,way){
	
	ascent(i in -8..8){
		ascent(e in 0..30){
		let shot = CreateObjShotA1(x+(i*73*way)*cos(dir+90),y+(i*73*way)*sin(dir+90),3-e*0.1,dir,118,10);
		ObjShot_SetAutoDelete(shot,false);
		swerve(shot,3-e*0.1,3-e*0.1,90,0);
		
	}
	if(!Hold(6)){break;}
	}
}

task swerve(obj,amt,speed,startpoint,time){
	wait(time);
	let flux = startpoint;
	loop(500){
		flux+=speed;
		ObjMove_SetAngularVelocity(obj,0+amt*sin(flux));
		if(!Hold(1)){break;}
	}
	Obj_Delete(obj);
}

task Fire{
	let dir = rand(0,360);
	let sw = 90;
	loop(5){
		loop(4){
		loop(2){
		let shot = CreateObjShotA1(EnemyX,EnemyY,3,dir,132,10);
		swerve(shot,5,6,sw,0);
		dir+=360/5;
		sw+=180;
		}
		PlaySoundO2(e_shot_00, 70);
		if(!Hold(1)){break;}
		}
	}
}