#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;


let obj = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
Obj_SetRenderPriority(obj, 0.3);
ObjPrim_SetTexture(obj, imgEnemy);
let screen = ObjPrim_Create(OBJ_SPRITE_2D);

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(2222248-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 160, 85/5, 35/5);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
	}
	yield;
}

let lang = 0;
task BossActions{
	SetAttackTimer(80);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		
		let face = GetCurrentScriptDirectory~"face/Yabusame_";
		ObjCutin_SetSpellcardM4("Infinity \"Dimensional Looping\"", 3500000, "ALLSTAR_LN", face~"09.png", 192, 192, 96);
		PlaySoundO1(spell_0);
		yield;
		ObjEnemyBossScene_StartSpell(objScene);
		ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/2,GetStgFrameHeight/2,13, 5);
		Hold(20);
		ScreenSplitYNP2;
		Hold(90);
		Hold(90);
		Hold(90);
		
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			let dir = rand(0,360);
			ascent(i in 0..12){
				ascent(j in 0..3){
					CreateWarpShotG1(EnemyX,EnemyY,3,dir+j*360/3,5,141,10,5);
					
				}
				PlaySoundO2(e_shot_00,75);
				if(!Hold(5)){break;}
			}
			dir+=360/12/2;
			ascent(i in 0..7){
				CreateWarpShotG1(EnemyX,EnemyY,1.5,dir+i*360/7,95,7,10,1);
				
			}
			PlaySoundO2(e_shot_01,70);
			if(!Hold(130)){break;}
			// ConcentrationA1(Enemy,"CHERRY",60,4,150,[255,192,56]);
			if(!Hold(90)){break;}
		}
	}
}

task ScreenSplitYNP2{
	
	
	if(!CreateRenderTarget("YabuPairNon")){
		RaiseError("Error has occurred");
	}
	let renderTexture = "YabuPairNon";
	
	Obj_SetValue(GetPlayerObjectID, "DisableInvert", true);
	
	let minren = 25;
	let maxren = 66;
	
	let bg = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	Obj_SetRenderPriorityI(bg, minren);
	ObjPrim_SetTexture(bg, img_Blank);
	ObjSpriteList2D_SetSourceRect(bg, 1, 1, 3, 3);
	ObjSpriteList2D_SetDestRect(bg, -128, -128, GetScreenWidth+128, GetScreenHeight+128);
	ObjRender_SetColor(bg, 192, 192, 144);
			ObjSpriteList2D_AddVertex(bg);
	
	let obj = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	Obj_SetRenderPriorityI(obj, maxren+1);
	// ObjPrim_SetTexture(obj, pathHealth);
	ObjPrim_SetTexture(obj, renderTexture);
	ObjSpriteList2D_SetSourceRect(obj, GetStgFrameLeft, GetStgFrameTop, GetStgFrameLeft+GetStgFrameWidth, GetStgFrameTop+GetStgFrameHeight);
	ObjSpriteList2D_SetDestRect(obj, 0, 0, GetStgFrameWidth, GetStgFrameHeight);
	
	WriteLog([GetStgFrameLeft, GetStgFrameTop, GetStgFrameLeft+GetStgFrameWidth, GetStgFrameTop+GetStgFrameHeight]);
	WriteLog([GetStgFrameWidth, GetStgFrameHeight]);
	
	let objeff = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	Obj_SetRenderPriorityI(objeff, 78);
	ObjPrim_SetTexture(objeff, img_Blank);
	ObjSpriteList2D_SetSourceRect(objeff, 1, 1, 3, 3);
	ObjRender_SetBlendType(objeff, BLEND_INV_DESTRGB);

	// Reset2DCamera;
	// TimeStopL1(255, 255, 255, 0, 3, 800, 20, maxren);
	SetInvalidRenderPriorityA1(20, maxren);
	
	
	
	ClearVertex;
	
	let moveX = 0;
	let moveY = 0;
	
	CreateSquare(0, 0);
	
	
	
	CreateSquare(-GetStgFrameWidth, GetStgFrameHeight);
	CreateSquare(-GetStgFrameWidth, 0);
	CreateSquare(-GetStgFrameWidth, -GetStgFrameHeight);
	CreateSquare(0, -GetStgFrameHeight);
	CreateSquare(0, GetStgFrameHeight);
	CreateSquare(GetStgFrameWidth, 0);
	CreateSquare(GetStgFrameWidth, GetStgFrameHeight);
	CreateSquare(GetStgFrameWidth, -GetStgFrameHeight);
	
	
	
	// ascent(x in 0..3){
		// ascent(y in 0..3){
			// CreateSquare(-GetStgFrameWidth, GetStgFrameHeight);
		// }
	// }
	
	let ang = round(rand(0, 4))*90;
	
	while(!EnemyDead){
		// moveX+=cos(ang);
		// moveY+=sin(ang);
		moveX+=1;
		
		// moveX = GetMouseX;
		// moveY = GetMouseY;
		
		// ang+=0.2;
		
		if(moveX > GetStgFrameWidth){moveX-=GetStgFrameWidth;}
		if(moveX < 0){moveX+=GetStgFrameWidth;}
		if(moveY > GetStgFrameHeight){moveY-=GetStgFrameHeight;}
		if(moveY < 0){moveY+=GetStgFrameHeight;}
		// if(moveX > GetStgFrameWidth){moveX = 0;}
		// if(moveX < 0){moveX = GetStgFrameWidth;}
		// if(moveY > GetStgFrameHeight){moveY = 0;}
		
		// if(ang > 360){
			// SaveRenderedTextureA1(renderTexture, "bloop.png");}
		// if(moveY < 0){moveY = GetStgFrameHeight;}
		
		yield;
	}
	
	Obj_Delete(obj);
	Obj_Delete(objeff);
	Obj_Delete(bg);
	Obj_SetValue(GetPlayerObjectID, "DisableInvert", false);
	ClearInvalidRenderPriority;
	
	task ClearVertex{
		while(!Obj_IsDeleted(obj)){
			ObjSpriteList2D_ClearVertexCount(obj);
			ObjSpriteList2D_ClearVertexCount(objeff);
			RenderToTextureA1(renderTexture, minren, maxren, true);
			yield;
		}
	}
	
	task CreateSquare(xoff, yoff){
		while(!Obj_IsDeleted(obj)){
		
			let dx = moveX+xoff;
			let dy = moveY+yoff;
			
			ObjRender_SetPosition(obj, dx, dy, 0);
			ObjSpriteList2D_AddVertex(obj);
			
			dx+=GetStgFrameWidth/2;
			dy+=GetStgFrameHeight/2;
			
			let ls = GetStgFrameWidth;
			let ws = GetStgFrameHeight;
			
			
			ObjRender_SetPosition(objeff, round(dx-ls/2), round(dy), 0);
			ObjSpriteList2D_SetDestRect(objeff, -3, round(-ws/2-3), 0, round(ws/2+3));
			ObjSpriteList2D_AddVertex(objeff);
			
			ObjRender_SetPosition(objeff, round(dx+ls/2), round(dy), 0);
			ObjSpriteList2D_SetDestRect(objeff, 0, round(-ws/2-3), 3, round(ws/2+3));
			ObjSpriteList2D_AddVertex(objeff);
			
			ObjRender_SetPosition(objeff, round(dx), round(dy-ws/2), 0);
			ObjSpriteList2D_SetDestRect(objeff, round(-ls/2-3), -3, round(ls/2-3), 0);
			ObjSpriteList2D_AddVertex(objeff);
			
			ObjRender_SetPosition(objeff, round(dx), round(dy+ws/2), 0);
			ObjSpriteList2D_SetDestRect(objeff, round(-ls/2-3), 0, round(ls/2-3), 3);
			ObjSpriteList2D_AddVertex(objeff);
			yield;
		}
	}
}

function CreateWarpShotG1(x, y, spd, ang, graph1, graph2, delay, count){
	let a = CreateShotA1(x, y, spd, ang, graph1, delay);
	GiveCollision(a);
	Obj_SetValue(a, "Damage", 24.5+argument/3);
	DoStuff;
	return a;
	
	task DoStuff{
		let Warp = false;
		
		let xm = spd*cos(ang);
		let ym = spd*sin(ang);
		
		while(count > 0 && !Obj_IsDeleted(a) && !EnemyDead){
			x = ObjMove_GetX(a);
			y = ObjMove_GetY(a);
			
			if(x > GetStgFrameWidth){x-=GetStgFrameWidth;Warp = true;}
			if(x < 0){x+=GetStgFrameWidth;Warp = true;}
			if(y > GetStgFrameHeight){y-=GetStgFrameHeight;Warp = true;}
			if(y < 0){y+=GetStgFrameHeight;Warp = true;}
			
			if(Warp){
				ObjMove_SetPosition(a, round(x), round(y));
				Warp = false;
				count--;
			}
			
			if(!Hold(1)){break;}
		}
		ObjShot_SetGraphic(a, graph2);
		
		while(!Obj_IsDeleted(a)){
			x = ObjMove_GetX(a);
			y = ObjMove_GetY(a);
			if(!Hold(1)){break;}
		}
		ObjShot_BulletBreak(x, y, graph2);
	}
	
	function GetNewCoordinate(nx, ny){
		if(nx > GetStgFrameWidth){return [0, ny];}
		if(nx < 0){return [GetStgFrameWidth, ny];}
		if(ny < 0){return [nx, GetStgFrameHeight];}
		if(ny > GetStgFrameHeight){return [nx, 0];}
		return [-1];
	}
}




