
let current = GetCurrentScriptDirectory;


let bg1 = current~"/bg/cdbg0.png";
let bg2 = current~"/bg/cdbg1.png";
let bg3 = current~"/bg/cdbg2.png";
let bg4 = current~"/bg/cdbg3.png";
let blank = current~"/bg/blank.png";

let fade = 0;
let a = GetEnemyBossSceneObjectID;
let SpellActive = (a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL));
let IsLocalScriptStopped = false;
let quality = GetCommonData("quality", 2);

@Initialize{
	SetCommonData("EffectSpeed", 1);
	SetCommonData("BGMod", 1);
	SpellBG;
}
@MainLoop{
	SpellActive = (a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL));
	yield;
}


task SpellBG{
	let bg_spin = 0;
	let mov = 0;
	
	let cdbgBG = CreateBackgroundImageA1(blank, 32, 0.28, 1);
	ObjSprite2D_SetSourceRect(cdbgBG, -32, -32, GetStgFrameWidth+32, GetStgFrameHeight+32);
	ObjSprite2D_SetDestRect(cdbgBG, -32, -32, GetStgFrameWidth+32, GetStgFrameHeight+32);
	ObjRender_SetPosition(cdbgBG, 0, 0, 0);
	ObjRender_SetColor(cdbgBG, 192, 192, 144);
	
	let cdbg1a1 = CreateBackgroundImageA1(bg1, 512, 0.29, 0.75);
	ObjRender_SetPosition(cdbg1a1, GetStgFrameWidth/2, GetStgFrameHeight/2, 0);
	ObjRender_SetColor(cdbg1a1, 192, 192, 192);
	
	let cdbg3a1 = CreateBackgroundImageA1(bg3, 787, 0.29, 3);
	ObjSprite2D_SetDestRect(cdbg3a1, -32, -32, GetStgFrameWidth+32, GetStgFrameHeight+32);
	// ObjRender_SetColor(cdbg3a1, 255, 255, 255);
	let cdbg3a2 = CreateBackgroundImageA1(bg4, 787, 0.29, 3);
	ObjSprite2D_SetDestRect(cdbg3a2, -32, -32, GetStgFrameWidth+32, GetStgFrameHeight+32);
	// ObjRender_SetColor(cdbg3a2, 160, 160, 255);
	
	CreateRoamingSquares;
	yield;
	// while(!IsCloseScript(GetScriptArgument("PluralID"))){
	SetAutoDeleteObject(true);
	while(!Obj_GetValueD(GetOwnScriptID, "SpellBackground", false)){
		a = GetEnemyBossSceneObjectID;
		
		if(SpellActive){
			fade = min(fade+0.05, 1)*GetCommonData("BGMod", 1);
		}else{
			fade=0;
		}
		
		ObjRender_SetAlpha(cdbg1a1, 240*fade+16*fade*cos(5*mov));
		ObjRender_SetAlpha(cdbgBG, 112*fade);
		
		ObjRender_SetAlpha(cdbg3a1, fade*128 + fade*96*sin(mov*1.1));
		ObjRender_SetAlpha(cdbg3a2, fade*128 + fade*96*sin(mov*1.1));
		
		mov+=0.3;
		
		let mx = 100+100*(sin(mov*1.3));
		let my = 300+100*(sin(mov));
		ObjSprite2D_SetSourceRect(cdbg3a1, -32+mx, -32+my, GetStgFrameWidth+32+mx, GetStgFrameHeight+32+my);
		ObjSprite2D_SetSourceRect(cdbg3a2, -32+mx, -32+my, GetStgFrameWidth+32+mx, GetStgFrameHeight+32+my);
		
		yield;
	}
	yield;
	IsLocalScriptStopped = true;
	//ScreenShatterA1(27, 28); //close scripts
	yield;
	Obj_Delete(cdbgBG);
	yield;
	CloseScript(GetOwnScriptID);
	
	
}

task CreateRoamingSquares{
	let objb = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	Obj_SetRenderPriority(objb, 0.28);
	ObjPrim_SetTexture(objb, bg2);
	ObjRender_SetColor(objb, 160, 160, 160);
	
	let obj = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	Obj_SetRenderPriority(obj, 0.29);
	ObjPrim_SetTexture(obj, bg2);
	
	
	ClearVertex;
	
	let ry = 0;
	let g = 0;
	
	while(!IsLocalScriptStopped){
		let ty = rand(24, GetStgFrameHeight-24);
		
		g+=(rand(0.75, 1.75));
		if(g > 4){g-=5;}
		
		if(ry > GetStgFrameHeight-24){ry = 24;}
		ry += rand(32, 128);
		
		FireBG(obj, round(g), -105, ry-80, GetStgFrameWidth+105, ry-80, rand(2.4, 4.8), 1);
		 
		
		FireBG(objb, truncate(rand(0, 4)), GetStgFrameWidth+105, ry-80, -105, ry-80, rand(2, 4), rand(0.65, 0.85));
		loop(round(rand(12, 22))){yield;}
	}
	
	Obj_Delete(obj);
	
	task FireBG(obj, graph, x, y, tx, ty, spd, scl){
	
		let ang = AngleToLocation(x, y, tx, ty);	
		let dist = GetDistance(x, y, tx, ty);
		let xm = cos(ang);
		let ym = sin(ang);
	
		while(dist > spd){
			dist = GetDistance(x, y, tx, ty);
			ObjRender_SetScaleXYZ(obj, scl, scl, 1);
			ObjRender_SetPosition(obj, x, y, 0);
			ObjSpriteList2D_SetSourceRect(obj, 0, 76*graph, 200, 76+76*graph);
			ObjSpriteList2D_SetDestCenter(obj);
			ObjSpriteList2D_AddVertex(obj);
			x+=spd*xm;
			y+=spd*ym;
			yield;
		}
	}

	task ClearVertex{
		while(!Obj_IsDeleted(obj)){
			ObjRender_SetAlpha(objb, 128*fade);
			ObjRender_SetAlpha(obj, 182*fade);
			ObjSpriteList2D_ClearVertexCount(obj);
			ObjSpriteList2D_ClearVertexCount(objb);
			yield;
		}
	}
}


function CreateInfiniteBackground(image, vertexcount, pri, innerrad, outerrad, lx, ly){
	let obj = ObjPrim_Create(OBJ_PRIMITIVE_2D);
	ObjPrim_SetPrimitiveType(obj, PRIMITIVE_TRIANGLESTRIP);
	ObjPrim_SetTexture(obj, image);
	Obj_SetRenderPriority(obj, pri);
	ObjPrim_SetVertexCount(obj, vertexcount);
	ObjRender_SetPosition(obj, lx, ly, 0);

	ascent(i in 0..vertexcount/2){
		let indexvert = i*2;
		let angle = 360/(vertexcount/2-1)*i;
		ObjPrim_SetVertexPosition(obj,indexvert+0,innerrad*cos(angle),innerrad*sin(angle),0);
		ObjPrim_SetVertexPosition(obj,indexvert+1,outerrad*cos(angle),outerrad*sin(angle),0);
	}
	return obj;
}


task ScreenShatterA1(minpri, maxpri){
	let renderTexture = "SpellBGShatter";
	let count = 0;
	let pathShader = GetMainStgScriptDirectory~"ds_system/shader/mask.hlsl";
	let pathMask = GetMainStgScriptDirectory~"ds_system/img/Masks/glass.png";
	if(!CreateRenderTarget(renderTexture)){
	RaiseError("Not enough VRAM to proceed.\nTry restarting the game and lowering the graphics quality.");}
		
	SetInvalidRenderPriorityA1(minpri, maxpri);
	Reset2DCamera;
	RenderToTextureA1(renderTexture, minpri, maxpri, true);
	ClearInvalidRenderPriority;
	
	let objShader = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjShader_SetShaderF(objShader, pathShader);
	ObjShader_SetTechnique(objShader, "TecMask");

	ObjShader_SetTexture(objShader, "textureMask_", renderTexture);
	SetShaderI(objShader, maxpri, maxpri);
	
	let countx = 30;
	let county = 10;
	ascent(x in 0..countx){
		ascent(y in 0..county){
			CreateFragmentA1(GetStgFrameWidth/countx*x+rand(-16, 16), GetStgFrameHeight/county*y+rand(-16, 16));
		}
	}
	yield;
	while(count > 0){yield;}
	ObjShader_ResetShader(objShader);
	ResetShaderI(maxpri, maxpri);
	RemoveTexture(renderTexture);
	Obj_Delete(objShader);

	yield;
	CloseScript(GetOwnScriptID);
	
	
	task CreateFragmentA1(x, y){
		count++;
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		ObjRender_SetAlpha(obj, 255);
		Obj_SetRenderPriority(obj, maxpri/100);
		ObjPrim_SetTexture(obj, pathMask);
		let ranxy = [round(rand(0,7)), round(rand(0,7))];
		ObjRender_SetScaleXYZ(obj, 1.5, 1.5, 1.5);
		ObjSprite2D_SetSourceRect(obj, ranxy[0]*48, ranxy[1]*48, (ranxy[0]+1)*48, (ranxy[1]+1)*48);
		ObjSprite2D_SetDestCenter(obj);
		
		let mid = GetStgFrameWidth/2;
		let data = [0, 0, 0, 
		(((x-mid)/mid)*rand(0, 5) + rand(-1,1))*2, 
		(2-absolute((x-mid)/mid)*3+rand(-1, 2))*0.70];
		
		let datamov = [rand(-8, 8), rand(-8, 8), rand(-8, 8), 0, 0.022];
		ObjRender_SetPosition(obj, x, y, 0);
		ObjRender_SetAngleXYZ(obj, data[0], data[1], data[2]);
		while(y<GetStgFrameHeight+64&&x<GetStgFrameWidth+64&&x>-64){
			ObjRender_SetPosition(obj, x, y, 0);
			ObjRender_SetAngleXYZ(obj, data[0], data[1], data[2]);
			
			
			data += datamov;
			datamov[4] = datamov[4]*1.06;
			x += data[3];
			y += data[4];
			
			yield;
		}
		Obj_Delete(obj);
		count--;
	}
}

task ScreenZoomA1(minpri, maxpri){
	let renderTexture = "SpellBGZoom";
	let count = 0;
	if(!CreateRenderTarget(renderTexture)){
	RaiseError("Not enough VRAM to proceed.\nTry restarting the game and lowering the graphics quality.");}
		
	SetInvalidRenderPriorityA1(minpri, maxpri);
	Reset2DCamera;
	RenderToTextureA1(renderTexture, minpri, maxpri, true);
	ClearInvalidRenderPriority;
	
	ascent(i in 0..3){
		CreateShadowImage(renderTexture, 8*i, 1.4-0.2*i);
	}
	yield;
	while(count > 0){yield;}
	
	RemoveTexture(renderTexture);
	
	task CreateShadowImage(source, delay, scl){
		count++;
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		Obj_SetRenderPriority(obj, maxpri);
		ObjPrim_SetTexture(obj, source);
		ObjSprite2D_SetSourceRect(obj, 32, 16, GetStgFrameWidth+32, GetStgFrameHeight+16);
		ObjSprite2D_SetDestRect(obj, 32, 16, GetStgFrameWidth+32, GetStgFrameHeight+16);
		ObjRender_SetPermitCamera(obj, false);
		
		ObjRender_SetAlpha(obj, 0);
		
		//ObjRender_SetAlpha(obj, 255);
		loop(delay){yield;}
		
		ObjRender_SetAlpha(obj, 255);
		
		scl--;
		
		ascent(i in 0..20){
			let mod = i/20;
			let dscl = 1+scl*mod;
			ObjRender_SetAlpha(obj, 255-255*mod);
			ObjRender_SetScaleXYZ(obj, dscl, dscl, 0);
			yield;
		}
		Obj_Delete(obj);
		count--;
	}

}

	
function CreateBackgroundImageA1(image, rect, pri, scale){
	let BG2PropObj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(BG2PropObj, BLEND_ALPHA);
	ObjRender_SetAlpha(BG2PropObj, 0);
	Obj_SetRenderPriority(BG2PropObj, pri);
	ObjPrim_SetTexture(BG2PropObj, image);
	ObjSprite2D_SetSourceRect(BG2PropObj, 0, 0, rect, rect);
	ObjSprite2D_SetDestCenter(BG2PropObj);
	ObjRender_SetScaleXYZ(BG2PropObj, scale, scale, 1);
	return BG2PropObj;
}
function CreateBackgroundImageB1(image, rect, pri, scale, left, top, right, bottom){
	let BG2PropObj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(BG2PropObj, BLEND_ALPHA);
	ObjRender_SetAlpha(BG2PropObj, 0);
	Obj_SetRenderPriority(BG2PropObj, pri);
	ObjPrim_SetTexture(BG2PropObj, image);
	ObjSprite2D_SetSourceRect(BG2PropObj, 0, 0, rect, rect);
	ObjSprite2D_SetDestRect(BG2PropObj, left, top, right, bottom);
	ObjRender_SetScaleXYZ(BG2PropObj, scale, scale, 1);
	return BG2PropObj;
}

function GetDistance(x1,y1,x2,y2){
	return(((x2-x1)^2+(y2-y1)^2)^(1/2))
}

function AngleToLocation(x1, y1, x2, y2){
	return atan2(y2 - y1, x2 - x1);
}


function GetPreviousDirectoryA1(str, depth){
	depth = max(0, depth-1);
	descent(i in 0..length(str)){
		if(str[i-1..i] == "/"){
			if(depth == 0){
				return str[0..i];
			}else{
				depth--;
			}
		}
	}
	RaiseError("GetPreviousDirectoryA1 received an invalid path for the string.");
}
