#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(2222248-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 160, 90, 85);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
	}
	yield;
}

task BossActions{
	SetAttackTimer(40);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{

		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/3, 13, 5);
	
		Hold(90);
		Hold(30);
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			let dir= rand(0,360);
			loop(3){
				first(dir,90);
				dir+=360/3;
			}
			PlaySoundO2(e_shot_00,70);
			if(!Hold(140)){break;}
			ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/7,GetStgFrameHeight/4-64, 13, 5);
			if(!Hold(100)){break;}
			
			dir = 0;
			loop(4){
				first(dir,rand(0,360));
				PlaySoundO2(e_shot_00,70);
				dir+=360/10;
				if(!Hold(10)){break;}
			}
			if(!Hold(100)){break;}
			ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/2,GetStgFrameHeight/3.5, 13, 5);
			if(!Hold(100)){break;}
			
			dir= rand(0,360);
			loop(3){
				first(dir,90);
				dir+=360/3;
			}
			PlaySoundO2(e_shot_00,70);
			if(!Hold(140)){break;}
			ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/7*6,GetStgFrameHeight/4-64, 13, 5);
			if(!Hold(100)){break;}
			
			dir = 180;
			loop(4){
				first(dir,rand(0,360));
				PlaySoundO2(e_shot_00,70);
				dir-=360/10;
				if(!Hold(10)){break;}
			}
			if(!Hold(100)){break;}
			ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/2,GetStgFrameHeight/3.5, 13, 5);
			if(!Hold(100)){break;}
		}
	}
}

task first(dir,secdir){
	let shot = CreateObjShotA2(EnemyX,EnemyY,3,dir,-0.04,0,99,10);
	ObjShot_SetSpellResist(shot,true);
	let las1 = CreateStraightLaserA1(EnemyX,-30,90,600,20,0,326,100000);
	let x = ObjMove_GetX(shot);
	let y = ObjMove_GetY(shot);
	loop(78){
		x = ObjMove_GetX(shot);
		y = ObjMove_GetY(shot);
		ObjMove_SetX(las1,x);
		if(!Hold(1)){return;}
	}
	Obj_Delete(las1);
	Obj_Delete(shot);
	let las2 = CreateStraightLaserA1(x,-30,90,600,20,10,326,0);
	PlaySoundO2(laser_1,40);
	second(x,y,secdir);
}

task second(x,y,secdir){
	let dir = secdir+360/6/2;
	ascent(i in 0..6){
		let shot = CreateObjShotA2(x,y,3.4,dir,-0.06,0,11,10);
		ObjShot_SetSpellResist(shot,true);
		if (i%2 == 0) {let las2 = CreateStraightLaserA1(x+600*cos(dir),y+600*sin(dir),dir+180,1200,20,0,326,100000); dt(las2,60);}
		third(shot,dir,60);
		dir+=360/6;
	}
	if(!Hold(60)){return;}
	ascent(i in 0..6){
		if (i%2 == 0) {CreateStraightLaserA1(x+600*cos(dir),y+600*sin(dir),dir+180,1200,16,10,326,0);}
		dir+=360/6;
	}
	PlaySoundO2(laser_3,40);
}

task third(obj,d,t){
	if(!Hold(t)){return;}
	let x = ObjMove_GetX(obj);
	let y = ObjMove_GetY(obj);
	Obj_Delete(obj);
	let dir = d;
	loop(5){
		CreateObjShotA1(x,y,1,dir,147,10);
		dir+=360/5;
	}
}

task dt(d,t){
	if(!Hold(t)){return;}
	Obj_Delete(d);
}