#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(2222248-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 160, 81/5, 35/5);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
	}
	yield;
}

task BossActions{
	SetAttackTimer(85);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		let face = GetCurrentScriptDirectory~"face/Yago_";
		ObjCutin_SetSpellcardM4("Brilliant Spear \"Blinding Slash\"", 3500000, "ALLSTAR_LN", face~"02.png", 176, 64, 64);
		// ObjCutin_SetSpellcardLayersM4([face~"04.png"]);
		PlaySoundO1(spell_0);
		yield;
		ObjEnemyBossScene_StartSpell(objScene);

	
		Hold(90);
		Hold(90);
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			ascent(i in 0..2){
				loop(3){
					let dist = EnemyX-GetPlayerX;
					let tmod = dist/absolute(dist);
					if(absolute(dist) < 72){tmod = GetRandomModifier;}
					CreateSpearShotLaserA1(EnemyX, EnemyY, 225, tmod);
					if(!Hold(60)){break;}
					ObjMove_SetDestAtWeight(Enemy, rand(64, GetStgFrameWidth-64), GetStgFrameHeight/2-rand(80, 160), 15, 7);
				
					if(!Hold(180-argument)){break;}
				}
				FireKnives(1-2*i);
			}
		}
	}
	
	task FireKnives(mod){
		let argm = round(30+argument^0.4*22);		
		
		let sang = rand(0, 360);
		
		let args = 0.9+argument/28;
		
		ascent(i in 0..argm){
			PlaySoundO2(e_shot_00, 70);
			let x = EnemyX+96*cos(sang);
			let y = EnemyY+96*sin(sang);
			let a = CreateObjShotA1(x, y, -args, (GetAngleToPlayer(Enemy))+60*sin(sang), 251, 10);
			ObjMove_SetMaxSpeed(a, args);
			ObjMove_SetAcceleration(a, args/30);
			sang+=1800/argm*mod;
			if(!Hold(8)){break;}
		}
		
	}
	
	
	function CreateSpearShotLaserA1(x, y, dur, mod){
	
		PlaySoundO1(laser_2);
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		CreateSpearData;
		return obj;
		
		task CreateSpearData{
			ObjPrim_SetTexture(obj, current~"Spear.png");
			Obj_SetRenderPriority(obj, 0.45);
			ObjSprite2D_SetSourceRect(obj, 0, 0, 46, 256);
			ObjSprite2D_SetDestCenter(obj);
			
			let scl = 0.4;
			ObjRender_SetPosition(obj, x, y, 0);
			ObjRender_SetScaleXYZ(obj, scl, scl, 1);
			IncreaseScale;
			
			
			ObRender_MoveBezierCurveB1(obj,dur,GetPlayerX+256*mod,GetStgFrameHeight/2,EnemyX,GetStgFrameHeight+64);
			
			let rang = rand(0, 360);
			
			let argc = 65-round(argument^0.5*4.75);
			
			ascent(i in 0..dur){
				ObjRender_SetAngleZ(obj, rang);
				rang+=15;
				
				if(i%argc == 0){
					x = ObjRender_GetX(obj);
					y = ObjRender_GetY(obj);
					ascent(i in 0..4){
						let lang = rang+360/4*i;
						let a = CreateStraightLaserA1(x, y, lang, 1024, 12, 40, 326, 60);
						ObjStLaser_SetSource(a, false);
						PlaySoundWithObject(a, 40);
					}
				}
				if(!Hold(1)){break;}
			}
			
			Obj_Delete(obj);
			task IncreaseScale{
				ascent(i in 0..10){
					let rscl = scl/9*i;
					ObjRender_SetScaleXYZ(obj, rscl, rscl, 1);
					if(!Hold(1)){break;}
				}
			}
			
			task PlaySoundWithObject(a, delay){
				loop(delay){if(!Hold(1)){break;}}
				if(Obj_IsDeleted(a)){return;}
				PlaySoundO2(laser_3, 48);
			}
			
		}
	}
}



